
/*  A Bison parser, made from ftpcmd.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	A	257
#define	B	258
#define	C	259
#define	E	260
#define	F	261
#define	I	262
#define	L	263
#define	N	264
#define	P	265
#define	R	266
#define	S	267
#define	T	268
#define	ALL	269
#define	SP	270
#define	CRLF	271
#define	COMMA	272
#define	USER	273
#define	PASS	274
#define	ACCT	275
#define	REIN	276
#define	QUIT	277
#define	PORT	278
#define	PASV	279
#define	TYPE	280
#define	STRU	281
#define	MODE	282
#define	RETR	283
#define	STOR	284
#define	APPE	285
#define	MLFL	286
#define	MAIL	287
#define	MSND	288
#define	MSOM	289
#define	MSAM	290
#define	MRSQ	291
#define	MRCP	292
#define	ALLO	293
#define	REST	294
#define	RNFR	295
#define	RNTO	296
#define	ABOR	297
#define	DELE	298
#define	CWD	299
#define	LIST	300
#define	NLST	301
#define	SITE	302
#define	STAT	303
#define	HELP	304
#define	NOOP	305
#define	MKD	306
#define	RMD	307
#define	PWD	308
#define	CDUP	309
#define	STOU	310
#define	SMNT	311
#define	SYST	312
#define	SIZE	313
#define	MDTM	314
#define	LPRT	315
#define	LPSV	316
#define	EPRT	317
#define	EPSV	318
#define	UMASK	319
#define	IDLE	320
#define	CHMOD	321
#define	LEXERR	322
#define	STRING	323
#define	NUMBER	324

#line 44 "ftpcmd.y"


#ifndef lint
#if 0
static char sccsid[] = "@(#)ftpcmd.y	8.3 (Berkeley) 4/6/94";
#else
static char rcsid[] = "$OpenBSD: ftpcmd.y,v 1.21 2000/06/17 19:42:18 deraadt Exp $";
#endif
#endif /* not lint */

#include <sys/param.h>
#include <sys/socket.h>
#include <sys/stat.h>

#include <netinet/in.h>
#include <arpa/ftp.h>

#include <ctype.h>
#include <errno.h>
#include <glob.h>
#include <pwd.h>
#include <setjmp.h>
#include <signal.h>
#ifdef ORIGINAL_SOURCE
#include <tzfile.h>
#endif /* ORIGINAL_SOURCE */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <syslog.h>
#include <time.h>
#include <unistd.h>
#include <netdb.h>

#include "extern.h"

extern	union sockunion data_dest;
extern	int logged_in;
extern	struct passwd *pw;
extern	int guest;
extern	int logging;
extern	int type;
extern	int form;
extern	int debug;
extern	int timeout;
extern	int maxtimeout;
extern  int pdata;
extern	char hostname[], remotehost[];
extern	char proctitle[];
extern	int usedefault;
extern  int transflag;
extern  char tmpline[];
extern	int portcheck;
extern	union sockunion his_addr;
extern	int umaskchange;

off_t	restart_point;

static	int cmd_type;
static	int cmd_form;
static	int cmd_bytesz;
char	cbuf[512];
char	*fromname;

#ifndef ORIGINAL_SOURCE /* Originally at the end */
#define	CMD	0	/* beginning of command */
#define	ARGS	1	/* expect miscellaneous arguments */
#define	STR1	2	/* expect SP followed by STRING */
#define	STR2	3	/* expect STRING */
#define	OSTR	4	/* optional SP then STRING */
#define	ZSTR1	5	/* SP then optional STRING */
#define	ZSTR2	6	/* optional STRING after SP */
#define	SITECMD	7	/* SITE command */
#define	NSTR	8	/* Number followed by a string */

struct tab {
	char	*name;
	short	token;
	short	state;
	short	implemented;	/* 1 if command is implemented */
	char	*help;
};

struct tab cmdtab[] = {		/* In order defined in RFC 765 */
	{ "USER", USER, STR1, 1,	"<sp> username" },
	{ "PASS", PASS, ZSTR1, 1,	"<sp> password" },
	{ "ACCT", ACCT, STR1, 0,	"(specify account)" },
	{ "SMNT", SMNT, ARGS, 0,	"(structure mount)" },
	{ "REIN", REIN, ARGS, 0,	"(reinitialize server state)" },
	{ "QUIT", QUIT, ARGS, 1,	"(terminate service)", },
#ifdef ORIGINAL_SOURCE
	{ "PORT", PORT, ARGS, 1,	"<sp> b0, b1, b2, b3, b4" },
#else
	{ "PORT", PORT, ARGS, 1,	"<sp> b0, b1, b2, b3, b4, b5" },
	/* There are *six* bytes after a PORT command, not *five*.
	 * Thanks to Quisar <quisar@ambre.net> for pointing this out
	 * to me.  For some weird reason, nearly every ftp server
	 * in existence seems to get this wrong...
	 * 	-- David Madore <david.madore@ens.fr> */
#endif
	{ "LPRT", LPRT, ARGS, 1,	"<sp> af, hal, h1, h2, h3,..., pal, p1, p2..." },
	{ "EPRT", EPRT, STR1, 1,	"<sp> |af|addr|port|" },
	{ "PASV", PASV, ARGS, 1,	"(set server in passive mode)" },
	{ "LPSV", LPSV, ARGS, 1,	"(set server in passive mode)" },
	{ "EPSV", EPSV, ARGS, 1,	"[<sp> af|ALL]" },
	{ "TYPE", TYPE, ARGS, 1,	"<sp> [ A | E | I | L ]" },
	{ "STRU", STRU, ARGS, 1,	"(specify file structure)" },
	{ "MODE", MODE, ARGS, 1,	"(specify transfer mode)" },
	{ "RETR", RETR, STR1, 1,	"<sp> file-name" },
	{ "STOR", STOR, STR1, 1,	"<sp> file-name" },
	{ "APPE", APPE, STR1, 1,	"<sp> file-name" },
	{ "MLFL", MLFL, OSTR, 0,	"(mail file)" },
	{ "MAIL", MAIL, OSTR, 0,	"(mail to user)" },
	{ "MSND", MSND, OSTR, 0,	"(mail send to terminal)" },
	{ "MSOM", MSOM, OSTR, 0,	"(mail send to terminal or mailbox)" },
	{ "MSAM", MSAM, OSTR, 0,	"(mail send to terminal and mailbox)" },
	{ "MRSQ", MRSQ, OSTR, 0,	"(mail recipient scheme question)" },
	{ "MRCP", MRCP, STR1, 0,	"(mail recipient)" },
	{ "ALLO", ALLO, ARGS, 1,	"allocate storage (vacuously)" },
	{ "REST", REST, ARGS, 1,	"<sp> offset (restart command)" },
	{ "RNFR", RNFR, STR1, 1,	"<sp> file-name" },
	{ "RNTO", RNTO, STR1, 1,	"<sp> file-name" },
	{ "ABOR", ABOR, ARGS, 1,	"(abort operation)" },
	{ "DELE", DELE, STR1, 1,	"<sp> file-name" },
	{ "CWD",  CWD,  OSTR, 1,	"[ <sp> directory-name ]" },
	{ "XCWD", CWD,	OSTR, 1,	"[ <sp> directory-name ]" },
	{ "LIST", LIST, OSTR, 1,	"[ <sp> path-name ]" },
	{ "NLST", NLST, OSTR, 1,	"[ <sp> path-name ]" },
	{ "SITE", SITE, SITECMD, 1,	"site-cmd [ <sp> arguments ]" },
	{ "SYST", SYST, ARGS, 1,	"(get type of operating system)" },
	{ "STAT", STAT, OSTR, 1,	"[ <sp> path-name ]" },
	{ "HELP", HELP, OSTR, 1,	"[ <sp> <string> ]" },
	{ "NOOP", NOOP, ARGS, 1,	"" },
	{ "MKD",  MKD,  STR1, 1,	"<sp> path-name" },
	{ "XMKD", MKD,  STR1, 1,	"<sp> path-name" },
	{ "RMD",  RMD,  STR1, 1,	"<sp> path-name" },
	{ "XRMD", RMD,  STR1, 1,	"<sp> path-name" },
	{ "PWD",  PWD,  ARGS, 1,	"(return current directory)" },
	{ "XPWD", PWD,  ARGS, 1,	"(return current directory)" },
	{ "CDUP", CDUP, ARGS, 1,	"(change to parent directory)" },
	{ "XCUP", CDUP, ARGS, 1,	"(change to parent directory)" },
	{ "STOU", STOU, STR1, 1,	"<sp> file-name" },
	{ "SIZE", SIZE, OSTR, 1,	"<sp> path-name" },
	{ "MDTM", MDTM, OSTR, 1,	"<sp> path-name" },
	{ NULL,   0,    0,    0,	0 }
};

struct tab sitetab[] = {
	{ "UMASK", UMASK, ARGS, 1,	"[ <sp> umask ]" },
	{ "IDLE", IDLE, ARGS, 1,	"[ <sp> maximum-idle-time ]" },
	{ "CHMOD", CHMOD, NSTR, 1,	"<sp> mode <sp> file-name" },
	{ "HELP", HELP, OSTR, 1,	"[ <sp> <string> ]" },
	{ NULL,   0,    0,    0,	0 }
};

static void	 help __P((struct tab *, char *));
static struct tab *
		 lookup __P((struct tab *, char *));
static void	 sizecmd __P((char *));
static int	 yylex __P((void));

extern int epsvall;
#endif /* not ORIGINAL_SOURCE */


#line 210 "ftpcmd.y"
typedef union {
	int	i;
	char   *s;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		278
#define	YYFLAG		-32768
#define	YYNTBASE	71

#define YYTRANSLATE(x) ((unsigned)(x) <= 324 ? yytranslate[x] : 88)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     1,     4,     7,    12,    17,    23,    29,    35,    41,
    45,    48,    53,    58,    61,    67,    73,    79,    85,    95,
   101,   107,   113,   117,   123,   127,   133,   139,   143,   149,
   155,   159,   163,   169,   172,   177,   180,   186,   192,   196,
   200,   205,   212,   218,   226,   236,   242,   250,   256,   260,
   266,   272,   275,   278,   284,   290,   292,   293,   295,   297,
   309,   327,   369,   371,   373,   375,   377,   381,   383,   387,
   389,   391,   395,   398,   400,   402,   404,   406,   408,   410,
   412,   414,   416
};

static const short yyrhs[] = {    -1,
    71,    72,     0,    71,    73,     0,    19,    16,    74,    17,
     0,    20,    16,    75,    17,     0,    24,    87,    16,    77,
    17,     0,    61,    87,    16,    78,    17,     0,    61,    87,
    16,    79,    17,     0,    63,    87,    16,    69,    17,     0,
    25,    87,    17,     0,    62,    17,     0,    64,    16,    70,
    17,     0,    64,    16,    15,    17,     0,    64,    17,     0,
    26,    87,    16,    81,    17,     0,    27,    87,    16,    82,
    17,     0,    28,    87,    16,    83,    17,     0,    39,    87,
    16,    70,    17,     0,    39,    87,    16,    70,    16,    12,
    16,    70,    17,     0,    29,    87,    16,    84,    17,     0,
    30,    87,    16,    84,    17,     0,    31,    87,    16,    84,
    17,     0,    47,    87,    17,     0,    47,    87,    16,    69,
    17,     0,    46,    87,    17,     0,    46,    87,    16,    84,
    17,     0,    49,    87,    16,    84,    17,     0,    49,    87,
    17,     0,    44,    87,    16,    84,    17,     0,    42,    87,
    16,    84,    17,     0,    43,    87,    17,     0,    45,    87,
    17,     0,    45,    87,    16,    84,    17,     0,    50,    17,
     0,    50,    16,    69,    17,     0,    51,    17,     0,    52,
    87,    16,    84,    17,     0,    53,    87,    16,    84,    17,
     0,    54,    87,    17,     0,    55,    87,    17,     0,    48,
    16,    50,    17,     0,    48,    16,    50,    16,    69,    17,
     0,    48,    16,    65,    87,    17,     0,    48,    16,    65,
    87,    16,    86,    17,     0,    48,    16,    67,    87,    16,
    86,    16,    84,    17,     0,    48,    16,    87,    66,    17,
     0,    48,    16,    87,    66,    16,    70,    17,     0,    56,
    87,    16,    84,    17,     0,    58,    87,    17,     0,    59,
    87,    16,    84,    17,     0,    60,    87,    16,    84,    17,
     0,    23,    17,     0,     1,    17,     0,    41,    87,    16,
    84,    17,     0,    40,    87,    16,    76,    17,     0,    69,
     0,     0,    69,     0,    70,     0,    70,    18,    70,    18,
    70,    18,    70,    18,    70,    18,    70,     0,    70,    18,
    70,    18,    70,    18,    70,    18,    70,    18,    70,    18,
    70,    18,    70,    18,    70,     0,    70,    18,    70,    18,
    70,    18,    70,    18,    70,    18,    70,    18,    70,    18,
    70,    18,    70,    18,    70,    18,    70,    18,    70,    18,
    70,    18,    70,    18,    70,    18,    70,    18,    70,    18,
    70,    18,    70,    18,    70,    18,    70,     0,    10,     0,
    14,     0,     5,     0,     3,     0,     3,    16,    80,     0,
     6,     0,     6,    16,    80,     0,     8,     0,     9,     0,
     9,    16,    76,     0,     9,    76,     0,     7,     0,    12,
     0,    11,     0,    13,     0,     4,     0,     5,     0,    85,
     0,    69,     0,    70,     0,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   250,   251,   256,   260,   265,   271,   300,   319,   338,   427,
   433,   440,   456,   466,   470,   504,   518,   532,   538,   544,
   551,   558,   565,   570,   577,   582,   589,   596,   601,   608,
   622,   627,   632,   639,   643,   661,   665,   672,   679,   684,
   689,   693,   700,   710,   728,   748,   755,   772,   779,   801,
   818,   848,   853,   859,   875,   892,   896,   900,   904,   908,
   932,   961,  1014,  1018,  1022,  1029,  1034,  1039,  1044,  1049,
  1053,  1058,  1064,  1072,  1076,  1080,  1087,  1091,  1095,  1102,
  1146,  1150,  1177
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","A","B",
"C","E","F","I","L","N","P","R","S","T","ALL","SP","CRLF","COMMA","USER","PASS",
"ACCT","REIN","QUIT","PORT","PASV","TYPE","STRU","MODE","RETR","STOR","APPE",
"MLFL","MAIL","MSND","MSOM","MSAM","MRSQ","MRCP","ALLO","REST","RNFR","RNTO",
"ABOR","DELE","CWD","LIST","NLST","SITE","STAT","HELP","NOOP","MKD","RMD","PWD",
"CDUP","STOU","SMNT","SYST","SIZE","MDTM","LPRT","LPSV","EPRT","EPSV","UMASK",
"IDLE","CHMOD","LEXERR","STRING","NUMBER","cmd_list","cmd","rcmd","username",
"password","byte_size","host_port","host_long_port4","host_long_port6","form_code",
"type_code","struct_code","mode_code","pathname","pathstring","octal_number",
"check_login", NULL
};
#endif

static const short yyr1[] = {     0,
    71,    71,    71,    72,    72,    72,    72,    72,    72,    72,
    72,    72,    72,    72,    72,    72,    72,    72,    72,    72,
    72,    72,    72,    72,    72,    72,    72,    72,    72,    72,
    72,    72,    72,    72,    72,    72,    72,    72,    72,    72,
    72,    72,    72,    72,    72,    72,    72,    72,    72,    72,
    72,    72,    72,    73,    73,    74,    75,    75,    76,    77,
    78,    79,    80,    80,    80,    81,    81,    81,    81,    81,
    81,    81,    81,    82,    82,    82,    83,    83,    83,    84,
    85,    86,    87
};

static const short yyr2[] = {     0,
     0,     2,     2,     4,     4,     5,     5,     5,     5,     3,
     2,     4,     4,     2,     5,     5,     5,     5,     9,     5,
     5,     5,     3,     5,     3,     5,     5,     3,     5,     5,
     3,     3,     5,     2,     4,     2,     5,     5,     3,     3,
     4,     6,     5,     7,     9,     5,     7,     5,     3,     5,
     5,     2,     2,     5,     5,     1,     0,     1,     1,    11,
    17,    41,     1,     1,     1,     1,     3,     1,     3,     1,
     1,     3,     2,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     0
};

static const short yydefact[] = {     1,
     0,     0,     0,     0,     0,    83,    83,    83,    83,    83,
    83,    83,    83,    83,    83,    83,    83,    83,    83,    83,
    83,    83,     0,    83,     0,     0,    83,    83,    83,    83,
    83,    83,    83,    83,    83,     0,    83,     0,     2,     3,
    53,     0,    57,    52,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    83,     0,     0,    34,    36,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    11,     0,     0,    14,    56,
     0,    58,     0,     0,    10,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    31,     0,     0,    32,     0,
    25,     0,    23,     0,    83,    83,     0,     0,    28,     0,
     0,     0,    39,    40,     0,    49,     0,     0,     0,     0,
     0,     0,     4,     5,     0,     0,    66,    68,    70,    71,
     0,    74,    76,    75,     0,    78,    79,    77,     0,    81,
     0,    80,     0,     0,     0,    59,     0,     0,     0,     0,
     0,     0,     0,     0,    41,     0,     0,     0,     0,    35,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    13,
    12,     0,     6,     0,     0,     0,    73,    15,    16,    17,
    20,    21,    22,     0,    18,    55,    54,    30,    29,    33,
    26,    24,     0,     0,    43,     0,     0,    46,    27,    37,
    38,    48,    50,    51,     0,     7,     8,     9,     0,    65,
    63,    64,    67,    69,    72,     0,    42,    82,     0,     0,
     0,     0,     0,     0,    44,     0,    47,     0,     0,     0,
     0,     0,     0,    19,    45,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    60,     0,     0,     0,     0,     0,
     0,    61,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    62,     0,     0
};

static const short yydefgoto[] = {     1,
    39,    40,    81,    83,   147,   126,   167,   168,   213,   131,
   135,   139,   141,   142,   219,    45
};

static const short yypact[] = {-32768,
    47,    -1,     8,    10,     6,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,    29,-32768,    46,    66,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,    68,-32768,    48,-32768,-32768,
-32768,    35,    51,-32768,   117,   109,   118,   119,   121,   122,
   123,   124,   125,   126,   127,   128,   129,   131,    52,    63,
    65,   -48,    98,    76,-32768,-32768,   132,   133,   134,   135,
   137,   138,   140,   141,   142,-32768,   143,   -12,-32768,-32768,
   144,-32768,   145,    80,-32768,   110,     2,     7,    85,    85,
    85,    90,    93,    85,    85,-32768,    85,    85,-32768,    85,
-32768,    95,-32768,   106,-32768,-32768,    99,    85,-32768,   149,
    85,    85,-32768,-32768,    85,-32768,    85,    85,    97,   100,
   151,   153,-32768,-32768,   154,   156,   155,   158,-32768,   -10,
   159,-32768,-32768,-32768,   160,-32768,-32768,-32768,   161,-32768,
   162,-32768,   163,   164,   108,-32768,   165,   166,   167,   168,
   169,   170,   171,   120,-32768,   113,   174,   115,   175,-32768,
   176,   177,   178,   179,   180,   157,   181,   182,   183,-32768,
-32768,   136,-32768,   107,   107,    93,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,   189,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,   185,   139,-32768,   139,   146,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,   147,-32768,-32768,-32768,   173,-32768,
-32768,-32768,-32768,-32768,-32768,   187,-32768,-32768,   188,   191,
   193,   186,   148,   150,-32768,    85,-32768,   152,   190,   194,
   195,   196,   172,-32768,-32768,   184,   197,   201,   192,   198,
   203,   205,   199,   200,-32768,   206,   202,   207,   204,   208,
   209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
   219,   220,   221,   222,   223,   225,   224,   226,   227,   228,
   229,   230,   231,   232,   233,-32768,   235,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,  -115,-32768,-32768,-32768,    38,-32768,
-32768,-32768,   -90,-32768,    31,    22
};


#define	YYLAST		303


static const short yytable[] = {   143,
   144,   104,   121,   148,   149,   176,   150,   151,   132,   152,
   136,   137,   133,   134,   177,    41,   105,   159,   106,   138,
   161,   162,    44,    42,   163,    43,   164,   165,    46,    47,
    48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
    58,    59,    60,    61,    62,    63,   277,     2,    67,    68,
    69,    70,    71,    72,    73,    74,    75,   122,    77,   146,
   215,    64,    65,    78,    79,     3,     4,    98,    99,     5,
     6,     7,     8,     9,    10,    11,    12,    13,   100,   101,
   102,   103,    66,   107,    76,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
    29,    30,    31,    80,    32,    33,    34,    35,    36,    37,
    38,   210,   127,   108,   109,   128,   211,   129,   130,    82,
   212,   154,   155,   184,   185,    85,   156,   157,   194,   195,
   197,   198,    84,    86,    87,   231,    88,    89,    90,    91,
    92,    93,    94,    95,   110,    96,    97,   111,   112,   125,
   113,   114,   115,   140,   116,   117,   118,   119,   120,   145,
   123,   124,   146,   153,   158,   160,   166,   170,   169,   171,
   174,   172,   173,   175,   205,   178,   179,   180,   181,   182,
   183,   186,   187,   188,   189,   190,   191,   192,   193,   196,
   223,   199,   200,   201,   202,   203,   204,   206,   207,   208,
   216,   217,   224,   228,   225,   209,   226,   233,   218,   227,
   234,   235,   214,   236,   239,   221,   222,   229,   240,   230,
   243,   232,   244,   247,   249,   251,   220,   253,     0,   255,
     0,   257,     0,   259,   278,   261,     0,   263,     0,   265,
     0,   237,   267,   269,     0,   271,     0,   273,     0,   275,
     0,     0,     0,   238,     0,     0,     0,     0,     0,     0,
     0,   241,     0,     0,     0,     0,     0,   242,   245,   246,
     0,   248,     0,   250,     0,     0,     0,     0,   252,     0,
   254,     0,   256,     0,   258,     0,   260,     0,   262,     0,
   264,     0,   266,   268,     0,     0,   270,     0,   272,     0,
   274,     0,   276
};

static const short yycheck[] = {    90,
    91,    50,    15,    94,    95,    16,    97,    98,     7,   100,
     4,     5,    11,    12,   130,    17,    65,   108,    67,    13,
   111,   112,    17,    16,   115,    16,   117,   118,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    16,    24,     0,     1,    27,    28,
    29,    30,    31,    32,    33,    34,    35,    70,    37,    70,
   176,    16,    17,    16,    17,    19,    20,    16,    17,    23,
    24,    25,    26,    27,    28,    29,    30,    31,    16,    17,
    16,    17,    17,    62,    17,    39,    40,    41,    42,    43,
    44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
    54,    55,    56,    69,    58,    59,    60,    61,    62,    63,
    64,     5,     3,    16,    17,     6,    10,     8,     9,    69,
    14,    16,    17,    16,    17,    17,   105,   106,    16,    17,
    16,    17,    16,    16,    16,   226,    16,    16,    16,    16,
    16,    16,    16,    16,    69,    17,    16,    16,    16,    70,
    17,    17,    16,    69,    17,    16,    16,    16,    16,    70,
    17,    17,    70,    69,    66,    17,    70,    17,    69,    17,
    16,    18,    17,    16,    18,    17,    17,    17,    17,    17,
    17,    17,    17,    17,    17,    17,    17,    17,    69,    16,
    18,    17,    17,    17,    17,    17,    17,    17,    17,    17,
    12,    17,    16,    18,    17,    70,    16,    18,    70,    17,
    17,    17,   175,    18,    18,    70,    70,    70,    18,    70,
    18,    70,    18,    18,    18,    18,   196,    18,    -1,    18,
    -1,    18,    -1,    18,     0,    18,    -1,    18,    -1,    18,
    -1,    70,    18,    18,    -1,    18,    -1,    18,    -1,    18,
    -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    70,    -1,    -1,    -1,    -1,    -1,    70,    70,    70,
    -1,    70,    -1,    70,    -1,    -1,    -1,    -1,    70,    -1,
    70,    -1,    70,    -1,    70,    -1,    70,    -1,    70,    -1,
    70,    -1,    70,    70,    -1,    -1,    70,    -1,    70,    -1,
    70,    -1,    70
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 2:
#line 252 "ftpcmd.y"
{
			fromname = (char *) 0;
			restart_point = (off_t) 0;
		;
    break;}
case 4:
#line 261 "ftpcmd.y"
{
			user(yyvsp[-1].s);
			free(yyvsp[-1].s);
		;
    break;}
case 5:
#line 266 "ftpcmd.y"
{
			pass(yyvsp[-1].s);
			memset(yyvsp[-1].s, 0, strlen(yyvsp[-1].s));
			free(yyvsp[-1].s);
		;
    break;}
case 6:
#line 272 "ftpcmd.y"
{
			if (yyvsp[-3].i) {
				if (yyvsp[-1].i) {
					usedefault = 1;
					reply(500,	
					    "Illegal PORT rejected (range errors).");
				} else if (portcheck &&
				    ntohs(data_dest.su_sin.sin_port) < IPPORT_RESERVED) {
					usedefault = 1;
					reply(500,
					    "Illegal PORT rejected (reserved port).");
				} else if (portcheck &&
				    memcmp(&data_dest.su_sin.sin_addr,
				    &his_addr.su_sin.sin_addr,
				    sizeof data_dest.su_sin.sin_addr)) {
					usedefault = 1;
					reply(500,
					    "Illegal PORT rejected (address wrong).");
				} else {
					usedefault = 0;
					if (pdata >= 0) {
						(void) close(pdata);
						pdata = -1;
					}
					reply(200, "PORT command successful.");
				}
			}
		;
    break;}
case 7:
#line 301 "ftpcmd.y"
{
			/* reject invalid host_long_port4 */
			if (yyvsp[-1].i) {
				reply(500, "Illegal LPRT command rejected");
				usedefault = 1;
			} else if (epsvall) {
				reply(501, "LPRT disallowed after EPSV ALL");
				usedefault = 1;
			} else {
				usedefault = 0;
				if (pdata >= 0) {
					(void) close(pdata);
					pdata = -1;
				}
				reply(200, "LPRT command successful.");
			}
		;
    break;}
case 8:
#line 320 "ftpcmd.y"
{
			/* reject invalid host_long_port6 */
			if (yyvsp[-1].i) {
				reply(500, "Illegal LPRT command rejected");
				usedefault = 1;
			} else if (epsvall) {
				reply(501, "LPRT disallowed after EPSV ALL");
				usedefault = 1;
			} else {
				usedefault = 0;
				if (pdata >= 0) {
					(void) close(pdata);
					pdata = -1;
				}
				reply(200, "LPRT command successful.");
			}
		;
    break;}
case 9:
#line 339 "ftpcmd.y"
{
			char *tmp = NULL;
			char *result[3];
			char *p, *q;
			char delim;
			struct addrinfo hints;
			struct addrinfo *res;
			int i;

			if (epsvall) {
				reply(501, "EPRT disallowed after EPSV ALL");
				goto eprt_done;
			}
			usedefault = 0;
			if (pdata >= 0) {
				(void) close(pdata);
				pdata = -1;
			}

			/*XXX checks for login */

			tmp = strdup(yyvsp[-1].s);
			if (!tmp) {
				fatal("not enough core.");
				/*NOTREACHED*/
			}
			p = tmp;
			delim = p[0];
			p++;
			memset(result, 0, sizeof(result));
			for (i = 0; i < 3; i++) {
				q = strchr(p, delim);
				if (!q || *q != delim) {
		parsefail:
					reply(500, "Invalid argument, rejected.");
					if (tmp)
						free(tmp);
					usedefault = 1;
					goto eprt_done;
				}
				*q++ = '\0';
				result[i] = p;
				p = q;
			}

			/* some more sanity check */
			p = result[0];
			while (*p) {
				if (!isdigit(*p))
					goto parsefail;
				p++;
			}
			p = result[2];
			while (*p) {
				if (!isdigit(*p))
					goto parsefail;
				p++;
			}

			memset(&hints, 0, sizeof(hints));
			if (atoi(result[0]) == 1)
				hints.ai_family = PF_INET;
			if (atoi(result[0]) == 2)
				hints.ai_family = PF_INET6;
			else
				hints.ai_family = PF_UNSPEC;	/*XXX*/
			hints.ai_socktype = SOCK_STREAM;
			if (getaddrinfo(result[1], result[2], &hints, &res))
				goto parsefail;
			memcpy(&data_dest, res->ai_addr, res->ai_addrlen);
			if (his_addr.su_family == AF_INET6 &&
			    data_dest.su_family == AF_INET6) {
#ifdef ORIGINAL_SOURCE /* Linux doesn't have this: why? */
				/* XXX more sanity checks! */
				data_dest.su_sin6.sin6_scope_id =
				    his_addr.su_sin6.sin6_scope_id;
#endif /* ORIGINAL_SOURCE */
			}
			free(tmp);
			tmp = NULL;
			if (pdata >= 0) {
				(void) close(pdata);
				pdata = -1;
			}
			reply(200, "EPRT command successful.");
		eprt_done:;
		;
    break;}
case 10:
#line 428 "ftpcmd.y"
{
			if (yyvsp[-1].i) {
				passive();
			}
		;
    break;}
case 11:
#line 434 "ftpcmd.y"
{
			if (epsvall)
				reply(501, "LPSV disallowed after EPSV ALL");
			else
				long_passive("LPSV", PF_UNSPEC);
		;
    break;}
case 12:
#line 441 "ftpcmd.y"
{
			int pf;
			switch (yyvsp[-1].i) {
			case 1:
				pf = PF_INET;
				break;
			case 2:
				pf = PF_INET6;
				break;
			default:
				pf = -1;	/*junk*/
				break;
			}
			long_passive("EPSV", pf);
		;
    break;}
case 13:
#line 457 "ftpcmd.y"
{
			if (!logged_in) {
				syslog(LOG_NOTICE, "long passive but not logged in");
				reply(503, "Login with USER first.");
			} else {
				reply(200, "EPSV ALL command successful.");
				epsvall++;
			}
		;
    break;}
case 14:
#line 467 "ftpcmd.y"
{
			long_passive("EPSV", PF_UNSPEC);
		;
    break;}
case 15:
#line 471 "ftpcmd.y"
{
			if (yyvsp[-3].i) {
				switch (cmd_type) {

				case TYPE_A:
					if (cmd_form == FORM_N) {
						reply(200, "Type set to A.");
						type = cmd_type;
						form = cmd_form;
					} else
						reply(504, "Form must be N.");
					break;

				case TYPE_E:
					reply(504, "Type E not implemented.");
					break;
	
				case TYPE_I:
					reply(200, "Type set to I.");
					type = cmd_type;
					break;

				case TYPE_L:
					if (cmd_bytesz == 8) {
					       reply(200,
					       "Type set to L (byte size 8).");
					       type = cmd_type;
					} else
					    reply(504, "Byte size must be 8.");

				}
			}
		;
    break;}
case 16:
#line 505 "ftpcmd.y"
{
			if (yyvsp[-3].i) {
				switch (yyvsp[-1].i) {

				case STRU_F:
					reply(200, "STRU F ok.");
					break;

				default:
					reply(504, "Unimplemented STRU type.");
				}
			}
		;
    break;}
case 17:
#line 519 "ftpcmd.y"
{
			if (yyvsp[-3].i) {
				switch (yyvsp[-1].i) {

				case MODE_S:
					reply(200, "MODE S ok.");
					break;

				default:
					reply(502, "Unimplemented MODE type.");
				}
			}
		;
    break;}
case 18:
#line 533 "ftpcmd.y"
{
			if (yyvsp[-3].i) {
				reply(202, "ALLO command ignored.");
			}
		;
    break;}
case 19:
#line 539 "ftpcmd.y"
{
			if (yyvsp[-7].i) {
				reply(202, "ALLO command ignored.");
			}
		;
    break;}
case 20:
#line 545 "ftpcmd.y"
{
			if (yyvsp[-3].i && yyvsp[-1].s != NULL)
				retrieve(NULL, yyvsp[-1].s);
			if (yyvsp[-1].s != NULL)
				free(yyvsp[-1].s);
		;
    break;}
case 21:
#line 552 "ftpcmd.y"
{
			if (yyvsp[-3].i && yyvsp[-1].s != NULL)
				store(yyvsp[-1].s, "w", 0);
			if (yyvsp[-1].s != NULL)
				free(yyvsp[-1].s);
		;
    break;}
case 22:
#line 559 "ftpcmd.y"
{
			if (yyvsp[-3].i && yyvsp[-1].s != NULL)
				store(yyvsp[-1].s, "a", 0);
			if (yyvsp[-1].s != NULL)
				free(yyvsp[-1].s);
		;
    break;}
case 23:
#line 566 "ftpcmd.y"
{
			if (yyvsp[-1].i)
				send_file_list(".");
		;
    break;}
case 24:
#line 571 "ftpcmd.y"
{
			if (yyvsp[-3].i && yyvsp[-1].s != NULL)
				send_file_list(yyvsp[-1].s);
			if (yyvsp[-1].s != NULL)
				free(yyvsp[-1].s);
		;
    break;}
case 25:
#line 578 "ftpcmd.y"
{
			if (yyvsp[-1].i)
				retrieve("/bin/ls -lgA", "");
		;
    break;}
case 26:
#line 583 "ftpcmd.y"
{
			if (yyvsp[-3].i && yyvsp[-1].s != NULL)
				retrieve("/bin/ls -lgA %s", yyvsp[-1].s);
			if (yyvsp[-1].s != NULL)
				free(yyvsp[-1].s);
		;
    break;}
case 27:
#line 590 "ftpcmd.y"
{
			if (yyvsp[-3].i && yyvsp[-1].s != NULL)
				statfilecmd(yyvsp[-1].s);
			if (yyvsp[-1].s != NULL)
				free(yyvsp[-1].s);
		;
    break;}
case 28:
#line 597 "ftpcmd.y"
{
			if (yyvsp[-1].i)
				statcmd();
		;
    break;}
case 29:
#line 602 "ftpcmd.y"
{
			if (yyvsp[-3].i && yyvsp[-1].s != NULL)
				delete(yyvsp[-1].s);
			if (yyvsp[-1].s != NULL)
				free(yyvsp[-1].s);
		;
    break;}
case 30:
#line 609 "ftpcmd.y"
{
			if (yyvsp[-3].i) {
				if (fromname) {
					renamecmd(fromname, yyvsp[-1].s);
					free(fromname);
					fromname = NULL;
				} else {
					reply(503, 
					  "Bad sequence of commands.");
				}
			}
			free(yyvsp[-1].s);
		;
    break;}
case 31:
#line 623 "ftpcmd.y"
{
			if (yyvsp[-1].i) 
				reply(225, "ABOR command successful.");
		;
    break;}
case 32:
#line 628 "ftpcmd.y"
{
			if (yyvsp[-1].i)
				cwd(pw->pw_dir);
		;
    break;}
case 33:
#line 633 "ftpcmd.y"
{
			if (yyvsp[-3].i && yyvsp[-1].s != NULL)
				cwd(yyvsp[-1].s);
			if (yyvsp[-1].s != NULL)
				free(yyvsp[-1].s);
		;
    break;}
case 34:
#line 640 "ftpcmd.y"
{
			help(cmdtab, NULL);
		;
    break;}
case 35:
#line 644 "ftpcmd.y"
{
			char *cp = yyvsp[-1].s;

			if (strncasecmp(cp, "SITE", 4) == 0) {
				cp = yyvsp[-1].s + 4;
				if (*cp == ' ')
					cp++;
				if (*cp)
					help(sitetab, cp);
				else
					help(sitetab, NULL);
			} else
				help(cmdtab, yyvsp[-1].s);

			if (yyvsp[-1].s != NULL)
				free (yyvsp[-1].s);
		;
    break;}
case 36:
#line 662 "ftpcmd.y"
{
			reply(200, "NOOP command successful.");
		;
    break;}
case 37:
#line 666 "ftpcmd.y"
{
			if (yyvsp[-3].i && yyvsp[-1].s != NULL)
				makedir(yyvsp[-1].s);
			if (yyvsp[-1].s != NULL)
				free(yyvsp[-1].s);
		;
    break;}
case 38:
#line 673 "ftpcmd.y"
{
			if (yyvsp[-3].i && yyvsp[-1].s != NULL)
				removedir(yyvsp[-1].s);
			if (yyvsp[-1].s != NULL)
				free(yyvsp[-1].s);
		;
    break;}
case 39:
#line 680 "ftpcmd.y"
{
			if (yyvsp[-1].i)
				pwd();
		;
    break;}
case 40:
#line 685 "ftpcmd.y"
{
			if (yyvsp[-1].i)
				cwd("..");
		;
    break;}
case 41:
#line 690 "ftpcmd.y"
{
			help(sitetab, NULL);
		;
    break;}
case 42:
#line 694 "ftpcmd.y"
{
			help(sitetab, yyvsp[-1].s);

			if (yyvsp[-1].s != NULL)
				free (yyvsp[-1].s);
		;
    break;}
case 43:
#line 701 "ftpcmd.y"
{
			int oldmask;

			if (yyvsp[-1].i) {
				oldmask = umask(0);
				(void) umask(oldmask);
				reply(200, "Current UMASK is %03o", oldmask);
			}
		;
    break;}
case 44:
#line 711 "ftpcmd.y"
{
			int oldmask;

			if (yyvsp[-3].i) {
				if ((yyvsp[-1].i == -1) || (yyvsp[-1].i > 0777)) {
					reply(501, "Bad UMASK value");
				} else if (!umaskchange) {
					reply(550,
					    "No permission to change umask.");
				} else {
					oldmask = umask(yyvsp[-1].i);
					reply(200,
					    "UMASK set to %03o (was %03o)",
					    yyvsp[-1].i, oldmask);
				}
			}
		;
    break;}
case 45:
#line 729 "ftpcmd.y"
{
			if (yyvsp[-5].i && (yyvsp[-1].s != NULL)) {
				if (yyvsp[-3].i > 0777)
					reply(501,
					    "CHMOD: Mode value must be between "
					    "0 and 0777");
				else if (!umaskchange)
					reply(550,
					    "No permission to change mode of %s.",
					    yyvsp[-1].s);
				else if (chmod(yyvsp[-1].s, yyvsp[-3].i) < 0)
					perror_reply(550, yyvsp[-1].s);
				else
					reply(200,
					    "CHMOD command successful.");
			}
			if (yyvsp[-1].s != NULL)
				free(yyvsp[-1].s);
		;
    break;}
case 46:
#line 749 "ftpcmd.y"
{
			if (yyvsp[-2].i)
			  reply(200,
	       		    "Current IDLE time limit is %d seconds; max %d",
				timeout, maxtimeout);
		;
    break;}
case 47:
#line 756 "ftpcmd.y"
{
			if (yyvsp[-4].i) {
				if (yyvsp[-1].i < 30 || yyvsp[-1].i > maxtimeout) {
				reply(501,
				    "Maximum IDLE time must be between "
				    "30 and %d seconds",
				    maxtimeout);
				} else {
					timeout = yyvsp[-1].i;
					(void) alarm((unsigned) timeout);
					reply(200,
					    "Maximum IDLE time set to %d seconds",
					    timeout);
				}
			}
		;
    break;}
case 48:
#line 773 "ftpcmd.y"
{
			if (yyvsp[-3].i && yyvsp[-1].s != NULL)
				store(yyvsp[-1].s, "w", 1);
			if (yyvsp[-1].s != NULL)
				free(yyvsp[-1].s);
		;
    break;}
case 49:
#line 780 "ftpcmd.y"
{
			if (yyvsp[-1].i)
#ifdef unix
#ifdef BSD
			reply(215, "UNIX Type: L%d Version: BSD-%d",
				NBBY, BSD);
#else /* BSD */
			reply(215, "UNIX Type: L%d", NBBY);
#endif /* BSD */
#else /* unix */
			reply(215, "UNKNOWN Type: L%d", NBBY);
#endif /* unix */
		;
    break;}
case 50:
#line 802 "ftpcmd.y"
{
			if (yyvsp[-3].i && yyvsp[-1].s != NULL)
				sizecmd(yyvsp[-1].s);
			if (yyvsp[-1].s != NULL)
				free(yyvsp[-1].s);
		;
    break;}
case 51:
#line 819 "ftpcmd.y"
{
			if (yyvsp[-3].i && yyvsp[-1].s != NULL) {
				struct stat stbuf;
				if (stat(yyvsp[-1].s, &stbuf) < 0)
					reply(550, "%s: %s",
					    yyvsp[-1].s, strerror(errno));
				else if (!S_ISREG(stbuf.st_mode)) {
					reply(550, "%s: not a plain file.", yyvsp[-1].s);
				} else {
					struct tm *t;
					t = gmtime(&stbuf.st_mtime);
#ifdef ORIGINAL_SOURCE
					reply(213,
					    "%04d%02d%02d%02d%02d%02d",
					    TM_YEAR_BASE + t->tm_year,
					    t->tm_mon+1, t->tm_mday,
					    t->tm_hour, t->tm_min, t->tm_sec);
#else
					reply(213,
					    "%04d%02d%02d%02d%02d%02d",
					    1900 + t->tm_year,
					    t->tm_mon+1, t->tm_mday,
					    t->tm_hour, t->tm_min, t->tm_sec);
#endif /* ORIGINAL_SOURCE */
				}
			}
			if (yyvsp[-1].s != NULL)
				free(yyvsp[-1].s);
		;
    break;}
case 52:
#line 849 "ftpcmd.y"
{
			reply(221, "Goodbye.");
			dologout(0);
		;
    break;}
case 53:
#line 854 "ftpcmd.y"
{
			yyerrok;
		;
    break;}
case 54:
#line 860 "ftpcmd.y"
{
			char *renamefrom();

			restart_point = (off_t) 0;
			if (yyvsp[-3].i && yyvsp[-1].s) {
				fromname = renamefrom(yyvsp[-1].s);
				if (fromname == NULL && yyvsp[-1].s) {
					free(yyvsp[-1].s);
				}
			} else {
				if (yyvsp[-1].s)
					free (yyvsp[-1].s);
			}
		;
    break;}
case 55:
#line 876 "ftpcmd.y"
{
			if (yyvsp[-3].i) {
			    fromname = NULL;
			    restart_point = yyvsp[-1].i;	/* XXX $4 is only "int" */
#ifdef ORIGINAL_SOURCE
			    reply(350, "Restarting at %qd. %s", restart_point,
			       "Send STORE or RETRIEVE to initiate transfer.");
#else
			    reply(350, "Restarting at %qd. %s", (long long) restart_point,
			       "Send STORE or RETRIEVE to initiate transfer.");
#endif /* ORIGINAL_SOURCE */
			}
		;
    break;}
case 57:
#line 897 "ftpcmd.y"
{
			yyval.s = (char *)calloc(1, sizeof(char));
		;
    break;}
case 60:
#line 910 "ftpcmd.y"
{
			char *a, *p;

			if (yyvsp[-10].i < 0 || yyvsp[-10].i > 255 || yyvsp[-8].i < 0 || yyvsp[-8].i > 255 ||
			    yyvsp[-6].i < 0 || yyvsp[-6].i > 255 || yyvsp[-4].i < 0 || yyvsp[-4].i > 255 ||
			    yyvsp[-2].i < 0 || yyvsp[-2].i > 255 || yyvsp[0].i < 0 || yyvsp[0].i > 255) {
				yyval.i = 1;
			} else {
#ifdef ORIGINAL_SOURCE
				data_dest.su_sin.sin_len = sizeof(struct sockaddr_in);
#endif /* ORIGINAL_SOURCE */
				data_dest.su_sin.sin_family = AF_INET;
				p = (char *)&data_dest.su_sin.sin_port;
				p[0] = yyvsp[-2].i; p[1] = yyvsp[0].i;
				a = (char *)&data_dest.su_sin.sin_addr;
				a[0] = yyvsp[-10].i; a[1] = yyvsp[-8].i; a[2] = yyvsp[-6].i; a[3] = yyvsp[-4].i;
				yyval.i = 0;
			}
		;
    break;}
case 61:
#line 935 "ftpcmd.y"
{
			char *a, *p;

			/* reject invalid LPRT command */
			if (yyvsp[-16].i != 4 || yyvsp[-14].i != 4
			 || yyvsp[-12].i < 0 || yyvsp[-12].i > 255 || yyvsp[-10].i < 0 || yyvsp[-10].i > 255
			 || yyvsp[-8].i < 0 || yyvsp[-8].i > 255 || yyvsp[-6].i < 0 || yyvsp[-6].i > 255
			 || yyvsp[-4].i != 2
			 || yyvsp[-2].i < 0 || yyvsp[-2].i > 255 || yyvsp[0].i < 0 || yyvsp[0].i > 255) {
				yyval.i = 1;
			} else {
#ifdef ORIGINAL_SOURCE
				data_dest.su_sin.sin_len =
					sizeof(struct sockaddr_in);
#endif /* ORIGINAL_SOURCE */
				data_dest.su_family = AF_INET;
				p = (char *)&data_dest.su_port;
				p[0] = yyvsp[-2].i; p[1] = yyvsp[0].i;
				a = (char *)&data_dest.su_sin.sin_addr;
				a[0] = yyvsp[-12].i; a[1] = yyvsp[-10].i; a[2] = yyvsp[-8].i; a[3] = yyvsp[-6].i;
				yyval.i = 0;
			}
		;
    break;}
case 62:
#line 967 "ftpcmd.y"
{
			char *a, *p;

			/* reject invalid LPRT command */
			if (yyvsp[-40].i != 6 || yyvsp[-38].i != 16
			 || yyvsp[-36].i < 0 || yyvsp[-36].i > 255 || yyvsp[-34].i < 0 || yyvsp[-34].i > 255
			 || yyvsp[-32].i < 0 || yyvsp[-32].i > 255 || yyvsp[-30].i < 0 || yyvsp[-30].i > 255
			 || yyvsp[-28].i < 0 || yyvsp[-28].i > 255 || yyvsp[-26].i < 0 || yyvsp[-26].i > 255
			 || yyvsp[-24].i < 0 || yyvsp[-24].i > 255 || yyvsp[-22].i < 0 || yyvsp[-22].i > 255
			 || yyvsp[-20].i < 0 || yyvsp[-20].i > 255 || yyvsp[-18].i < 0 || yyvsp[-18].i > 255
			 || yyvsp[-16].i < 0 || yyvsp[-16].i > 255 || yyvsp[-14].i < 0 || yyvsp[-14].i > 255
			 || yyvsp[-12].i < 0 || yyvsp[-12].i > 255 || yyvsp[-10].i < 0 || yyvsp[-10].i > 255
			 || yyvsp[-8].i < 0 || yyvsp[-8].i > 255 || yyvsp[-6].i < 0 || yyvsp[-6].i > 255
			 || yyvsp[-4].i != 2
			 || yyvsp[-2].i < 0 || yyvsp[-2].i > 255 || yyvsp[0].i < 0 || yyvsp[0].i > 255) {
				yyval.i = 1;
			} else {
#ifdef ORIGINAL_SOURCE
				data_dest.su_sin6.sin6_len =
					sizeof(struct sockaddr_in6);
#endif /* ORIGINAL_SOURCE */
				data_dest.su_family = AF_INET6;
				p = (char *)&data_dest.su_port;
				p[0] = yyvsp[-2].i; p[1] = yyvsp[0].i;
				a = (char *)&data_dest.su_sin6.sin6_addr;
				 a[0] =  yyvsp[-36].i;  a[1] =  yyvsp[-34].i;
				 a[2] =  yyvsp[-32].i;  a[3] = yyvsp[-30].i;
				 a[4] = yyvsp[-28].i;  a[5] = yyvsp[-26].i;
				 a[6] = yyvsp[-24].i;  a[7] = yyvsp[-22].i;
				 a[8] = yyvsp[-20].i;  a[9] = yyvsp[-18].i;
				a[10] = yyvsp[-16].i; a[11] = yyvsp[-14].i;
				a[12] = yyvsp[-12].i; a[13] = yyvsp[-10].i;
				a[14] = yyvsp[-8].i; a[15] = yyvsp[-6].i;
				if (his_addr.su_family == AF_INET6) {
#ifdef ORIGINAL_SOURCE /* Linux doesn't have this: why? */
					/* XXX more sanity checks! */
					data_dest.su_sin6.sin6_scope_id =
					    his_addr.su_sin6.sin6_scope_id;
#endif /* ORIGINAL_SOURCE */
				}

				yyval.i = 0;
			}
		;
    break;}
case 63:
#line 1015 "ftpcmd.y"
{
			yyval.i = FORM_N;
		;
    break;}
case 64:
#line 1019 "ftpcmd.y"
{
			yyval.i = FORM_T;
		;
    break;}
case 65:
#line 1023 "ftpcmd.y"
{
			yyval.i = FORM_C;
		;
    break;}
case 66:
#line 1030 "ftpcmd.y"
{
			cmd_type = TYPE_A;
			cmd_form = FORM_N;
		;
    break;}
case 67:
#line 1035 "ftpcmd.y"
{
			cmd_type = TYPE_A;
			cmd_form = yyvsp[0].i;
		;
    break;}
case 68:
#line 1040 "ftpcmd.y"
{
			cmd_type = TYPE_E;
			cmd_form = FORM_N;
		;
    break;}
case 69:
#line 1045 "ftpcmd.y"
{
			cmd_type = TYPE_E;
			cmd_form = yyvsp[0].i;
		;
    break;}
case 70:
#line 1050 "ftpcmd.y"
{
			cmd_type = TYPE_I;
		;
    break;}
case 71:
#line 1054 "ftpcmd.y"
{
			cmd_type = TYPE_L;
			cmd_bytesz = NBBY;
		;
    break;}
case 72:
#line 1059 "ftpcmd.y"
{
			cmd_type = TYPE_L;
			cmd_bytesz = yyvsp[0].i;
		;
    break;}
case 73:
#line 1065 "ftpcmd.y"
{
			cmd_type = TYPE_L;
			cmd_bytesz = yyvsp[0].i;
		;
    break;}
case 74:
#line 1073 "ftpcmd.y"
{
			yyval.i = STRU_F;
		;
    break;}
case 75:
#line 1077 "ftpcmd.y"
{
			yyval.i = STRU_R;
		;
    break;}
case 76:
#line 1081 "ftpcmd.y"
{
			yyval.i = STRU_P;
		;
    break;}
case 77:
#line 1088 "ftpcmd.y"
{
			yyval.i = MODE_S;
		;
    break;}
case 78:
#line 1092 "ftpcmd.y"
{
			yyval.i = MODE_B;
		;
    break;}
case 79:
#line 1096 "ftpcmd.y"
{
			yyval.i = MODE_C;
		;
    break;}
case 80:
#line 1103 "ftpcmd.y"
{
			/*
			 * Problem: this production is used for all pathname
			 * processing, but only gives a 550 error reply.
			 * This is a valid reply in some cases but not in others.
			 */
			if (logged_in && yyvsp[0].s && strchr(yyvsp[0].s, '~') != NULL) {
				glob_t gl;
#ifdef ORIGINAL_SOURCE
				int flags =
				 GLOB_BRACE|GLOB_NOCHECK|GLOB_QUOTE|GLOB_TILDE;
#else
				int flags =
				 GLOB_BRACE|GLOB_NOCHECK|GLOB_TILDE;
#endif /* ORIGINAL_SOURCE */
				char *pptr = yyvsp[0].s;

				/*
				 * glob() will only find a leading ~, but
				 * Netscape kindly puts a slash in front of
				 * it for publish URLs.  There needs to be
				 * a flag for glob() that expands tildes
				 * anywhere in the string.
				 */
				if ((pptr[0] == '/') && (pptr[1] == '~'))
					pptr++;

				memset(&gl, 0, sizeof(gl));
				if (glob(pptr, flags, NULL, &gl) ||
				    gl.gl_pathc == 0) {
					reply(550, "not found");
					yyval.s = NULL;
				} else {
					yyval.s = strdup(gl.gl_pathv[0]);
				}
				globfree(&gl);
				free(yyvsp[0].s);
			} else
				yyval.s = yyvsp[0].s;
		;
    break;}
case 82:
#line 1151 "ftpcmd.y"
{
			int ret, dec, multby, digit;

			/*
			 * Convert a number that was read as decimal number
			 * to what it would be if it had been read as octal.
			 */
			dec = yyvsp[0].i;
			multby = 1;
			ret = 0;
			while (dec) {
				digit = dec%10;
				if (digit > 7) {
					ret = -1;
					break;
				}
				ret += digit * multby;
				multby *= 8;
				dec /= 10;
			}
			yyval.i = ret;
		;
    break;}
case 83:
#line 1178 "ftpcmd.y"
{
			if (logged_in)
				yyval.i = 1;
			else {
				reply(530, "Please login with USER and PASS.");
				yyval.i = 0;
			}
		;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 1188 "ftpcmd.y"


extern jmp_buf errcatch;

#ifdef ORIGINAL_SOURCE /* Moved to the beginning */
#define	CMD	0	/* beginning of command */
#define	ARGS	1	/* expect miscellaneous arguments */
#define	STR1	2	/* expect SP followed by STRING */
#define	STR2	3	/* expect STRING */
#define	OSTR	4	/* optional SP then STRING */
#define	ZSTR1	5	/* SP then optional STRING */
#define	ZSTR2	6	/* optional STRING after SP */
#define	SITECMD	7	/* SITE command */
#define	NSTR	8	/* Number followed by a string */

struct tab {
	char	*name;
	short	token;
	short	state;
	short	implemented;	/* 1 if command is implemented */
	char	*help;
};

struct tab cmdtab[] = {		/* In order defined in RFC 765 */
	{ "USER", USER, STR1, 1,	"<sp> username" },
	{ "PASS", PASS, ZSTR1, 1,	"<sp> password" },
	{ "ACCT", ACCT, STR1, 0,	"(specify account)" },
	{ "SMNT", SMNT, ARGS, 0,	"(structure mount)" },
	{ "REIN", REIN, ARGS, 0,	"(reinitialize server state)" },
	{ "QUIT", QUIT, ARGS, 1,	"(terminate service)", },
	{ "PORT", PORT, ARGS, 1,	"<sp> b0, b1, b2, b3, b4" },
	{ "LPRT", LPRT, ARGS, 1,	"<sp> af, hal, h1, h2, h3,..., pal, p1, p2..." },
	{ "EPRT", EPRT, STR1, 1,	"<sp> |af|addr|port|" },
	{ "PASV", PASV, ARGS, 1,	"(set server in passive mode)" },
	{ "LPSV", LPSV, ARGS, 1,	"(set server in passive mode)" },
	{ "EPSV", EPSV, ARGS, 1,	"[<sp> af|ALL]" },
	{ "TYPE", TYPE, ARGS, 1,	"<sp> [ A | E | I | L ]" },
	{ "STRU", STRU, ARGS, 1,	"(specify file structure)" },
	{ "MODE", MODE, ARGS, 1,	"(specify transfer mode)" },
	{ "RETR", RETR, STR1, 1,	"<sp> file-name" },
	{ "STOR", STOR, STR1, 1,	"<sp> file-name" },
	{ "APPE", APPE, STR1, 1,	"<sp> file-name" },
	{ "MLFL", MLFL, OSTR, 0,	"(mail file)" },
	{ "MAIL", MAIL, OSTR, 0,	"(mail to user)" },
	{ "MSND", MSND, OSTR, 0,	"(mail send to terminal)" },
	{ "MSOM", MSOM, OSTR, 0,	"(mail send to terminal or mailbox)" },
	{ "MSAM", MSAM, OSTR, 0,	"(mail send to terminal and mailbox)" },
	{ "MRSQ", MRSQ, OSTR, 0,	"(mail recipient scheme question)" },
	{ "MRCP", MRCP, STR1, 0,	"(mail recipient)" },
	{ "ALLO", ALLO, ARGS, 1,	"allocate storage (vacuously)" },
	{ "REST", REST, ARGS, 1,	"<sp> offset (restart command)" },
	{ "RNFR", RNFR, STR1, 1,	"<sp> file-name" },
	{ "RNTO", RNTO, STR1, 1,	"<sp> file-name" },
	{ "ABOR", ABOR, ARGS, 1,	"(abort operation)" },
	{ "DELE", DELE, STR1, 1,	"<sp> file-name" },
	{ "CWD",  CWD,  OSTR, 1,	"[ <sp> directory-name ]" },
	{ "XCWD", CWD,	OSTR, 1,	"[ <sp> directory-name ]" },
	{ "LIST", LIST, OSTR, 1,	"[ <sp> path-name ]" },
	{ "NLST", NLST, OSTR, 1,	"[ <sp> path-name ]" },
	{ "SITE", SITE, SITECMD, 1,	"site-cmd [ <sp> arguments ]" },
	{ "SYST", SYST, ARGS, 1,	"(get type of operating system)" },
	{ "STAT", STAT, OSTR, 1,	"[ <sp> path-name ]" },
	{ "HELP", HELP, OSTR, 1,	"[ <sp> <string> ]" },
	{ "NOOP", NOOP, ARGS, 1,	"" },
	{ "MKD",  MKD,  STR1, 1,	"<sp> path-name" },
	{ "XMKD", MKD,  STR1, 1,	"<sp> path-name" },
	{ "RMD",  RMD,  STR1, 1,	"<sp> path-name" },
	{ "XRMD", RMD,  STR1, 1,	"<sp> path-name" },
	{ "PWD",  PWD,  ARGS, 1,	"(return current directory)" },
	{ "XPWD", PWD,  ARGS, 1,	"(return current directory)" },
	{ "CDUP", CDUP, ARGS, 1,	"(change to parent directory)" },
	{ "XCUP", CDUP, ARGS, 1,	"(change to parent directory)" },
	{ "STOU", STOU, STR1, 1,	"<sp> file-name" },
	{ "SIZE", SIZE, OSTR, 1,	"<sp> path-name" },
	{ "MDTM", MDTM, OSTR, 1,	"<sp> path-name" },
	{ NULL,   0,    0,    0,	0 }
};

struct tab sitetab[] = {
	{ "UMASK", UMASK, ARGS, 1,	"[ <sp> umask ]" },
	{ "IDLE", IDLE, ARGS, 1,	"[ <sp> maximum-idle-time ]" },
	{ "CHMOD", CHMOD, NSTR, 1,	"<sp> mode <sp> file-name" },
	{ "HELP", HELP, OSTR, 1,	"[ <sp> <string> ]" },
	{ NULL,   0,    0,    0,	0 }
};

static void	 help __P((struct tab *, char *));
static struct tab *
		 lookup __P((struct tab *, char *));
static void	 sizecmd __P((char *));
static int	 yylex __P((void));

extern int epsvall;
#endif /* ORIGINAL_SOURCE */

static struct tab *
lookup(p, cmd)
	struct tab *p;
	char *cmd;
{

	for (; p->name != NULL; p++)
		if (strcmp(cmd, p->name) == 0)
			return (p);
	return (0);
}

#include <arpa/telnet.h>

/*
 * getline - a hacked up version of fgets to ignore TELNET escape codes.
 */
#ifdef ORIGINAL_SOURCE
char *
getline(s, n, iop)
	char *s;
	int n;
	FILE *iop;
#else
char *
getline_ORIG(s, n, iop)
	char *s;
	int n;
	FILE *iop;
#endif /* ORIGINAL_SOURCE */
{
	int c;
	register char *cs;

	cs = s;
/* tmpline may contain saved command from urgent mode interruption */
	for (c = 0; tmpline[c] != '\0' && --n > 0; ++c) {
		*cs++ = tmpline[c];
		if (tmpline[c] == '\n') {
			*cs++ = '\0';
			if (debug)
				syslog(LOG_DEBUG, "command: %s", s);
			tmpline[0] = '\0';
			return(s);
		}
		if (c == 0)
			tmpline[0] = '\0';
	}
	while ((c = getc(iop)) != EOF) {
		c &= 0377;
		if (c == IAC) {
		    if ((c = getc(iop)) != EOF) {
			c &= 0377;
			switch (c) {
			case WILL:
			case WONT:
				c = getc(iop);
				printf("%c%c%c", IAC, DONT, 0377&c);
				(void) fflush(stdout);
				continue;
			case DO:
			case DONT:
				c = getc(iop);
				printf("%c%c%c", IAC, WONT, 0377&c);
				(void) fflush(stdout);
				continue;
			case IAC:
				break;
			default:
				continue;	/* ignore command */
			}
		    }
		}
		*cs++ = c;
		if (--n <= 0 || c == '\n')
			break;
	}
	if (c == EOF && cs == s)
		return (NULL);
	*cs++ = '\0';
	if (debug) {
		if (!guest && strncasecmp("pass ", s, 5) == 0) {
			/* Don't syslog passwords */
			syslog(LOG_DEBUG, "command: %.5s ???", s);
		} else {
			register char *cp;
			register int len;

			/* Don't syslog trailing CR-LF */
			len = strlen(s);
			cp = s + len - 1;
			while (cp >= s && (*cp == '\n' || *cp == '\r')) {
				--cp;
				--len;
			}
			syslog(LOG_DEBUG, "command: %.*s", len, s);
		}
	}
	return (s);
}

void
toolong(signo)
	int signo;
{

	reply(421,
	    "Timeout (%d seconds): closing control connection.", timeout);
	if (logging)
		syslog(LOG_INFO, "User %s timed out after %d seconds",
		    (pw ? pw -> pw_name : "unknown"), timeout);
	dologout(1);
}

static int
yylex()
{
	static int cpos, state;
	char *cp, *cp2;
	struct tab *p;
	int n;
	char c;

	for (;;) {
		switch (state) {

		case CMD:
			(void) signal(SIGALRM, toolong);
			(void) alarm((unsigned) timeout);
#ifdef ORIGINAL_SOURCE
			if (getline(cbuf, sizeof(cbuf)-1, stdin) == NULL) {
#else
			if (getline_ORIG(cbuf, sizeof(cbuf)-1, stdin) == NULL) {
#endif /* ORIGINAL_SOURCE */
				reply(221, "You could at least say goodbye.");
				dologout(0);
			}
			(void) alarm(0);
			if ((cp = strchr(cbuf, '\r'))) {
				*cp++ = '\n';
				*cp = '\0';
			}
#ifdef HASSETPROCTITLE
			if (strncasecmp(cbuf, "PASS", 4) != 0) {
				if ((cp = strpbrk(cbuf, "\n"))) {
					c = *cp;
					*cp = '\0';
					setproctitle("%s: %s", proctitle, cbuf);
					*cp = c;
				}
			}
#endif /* HASSETPROCTITLE */
			if ((cp = strpbrk(cbuf, " \n")))
				cpos = cp - cbuf;
			if (cpos == 0)
				cpos = 4;
			c = cbuf[cpos];
			cbuf[cpos] = '\0';
			upper(cbuf);
			p = lookup(cmdtab, cbuf);
			cbuf[cpos] = c;
			if (p != 0) {
				if (p->implemented == 0) {
					nack(p->name);
					longjmp(errcatch,0);
					/* NOTREACHED */
				}
				state = p->state;
				yylval.s = p->name;
				return (p->token);
			}
			break;

		case SITECMD:
			if (cbuf[cpos] == ' ') {
				cpos++;
				return (SP);
			}
			cp = &cbuf[cpos];
			if ((cp2 = strpbrk(cp, " \n")))
				cpos = cp2 - cbuf;
			c = cbuf[cpos];
			cbuf[cpos] = '\0';
			upper(cp);
			p = lookup(sitetab, cp);
			cbuf[cpos] = c;
			if (p != 0) {
				if (p->implemented == 0) {
					state = CMD;
					nack(p->name);
					longjmp(errcatch,0);
					/* NOTREACHED */
				}
				state = p->state;
				yylval.s = p->name;
				return (p->token);
			}
			state = CMD;
			break;

		case OSTR:
			if (cbuf[cpos] == '\n') {
				state = CMD;
				return (CRLF);
			}
			/* FALLTHROUGH */

		case STR1:
		case ZSTR1:
		dostr1:
			if (cbuf[cpos] == ' ') {
				cpos++;
				state = state == OSTR ? STR2 : state+1;
				return (SP);
			}
			break;

		case ZSTR2:
			if (cbuf[cpos] == '\n') {
				state = CMD;
				return (CRLF);
			}
			/* FALLTHROUGH */

		case STR2:
			cp = &cbuf[cpos];
			n = strlen(cp);
			cpos += n - 1;
			/*
			 * Make sure the string is nonempty and \n terminated.
			 */
			if (n > 1 && cbuf[cpos] == '\n') {
				cbuf[cpos] = '\0';
				yylval.s = strdup(cp);
				if (yylval.s == NULL)
					fatal("Ran out of memory.");
				cbuf[cpos] = '\n';
				state = ARGS;
				return (STRING);
			}
			break;

		case NSTR:
			if (cbuf[cpos] == ' ') {
				cpos++;
				return (SP);
			}
			if (isdigit(cbuf[cpos])) {
				cp = &cbuf[cpos];
				while (isdigit(cbuf[++cpos]))
					;
				c = cbuf[cpos];
				cbuf[cpos] = '\0';
				yylval.i = atoi(cp);
				cbuf[cpos] = c;
				state = STR1;
				return (NUMBER);
			}
			state = STR1;
			goto dostr1;

		case ARGS:
			if (isdigit(cbuf[cpos])) {
				cp = &cbuf[cpos];
				while (isdigit(cbuf[++cpos]))
					;
				c = cbuf[cpos];
				cbuf[cpos] = '\0';
				yylval.i = atoi(cp);
				cbuf[cpos] = c;
				return (NUMBER);
			}
			if (strncasecmp(&cbuf[cpos], "ALL", 3) == 0
			 && !isalnum(cbuf[cpos + 3])) {
				yylval.s = strdup("ALL");
				cpos += 3;
				return ALL;
			}
			switch (cbuf[cpos++]) {

			case '\n':
				state = CMD;
				return (CRLF);

			case ' ':
				return (SP);

			case ',':
				return (COMMA);

			case 'A':
			case 'a':
				return (A);

			case 'B':
			case 'b':
				return (B);

			case 'C':
			case 'c':
				return (C);

			case 'E':
			case 'e':
				return (E);

			case 'F':
			case 'f':
				return (F);

			case 'I':
			case 'i':
				return (I);

			case 'L':
			case 'l':
				return (L);

			case 'N':
			case 'n':
				return (N);

			case 'P':
			case 'p':
				return (P);

			case 'R':
			case 'r':
				return (R);

			case 'S':
			case 's':
				return (S);

			case 'T':
			case 't':
				return (T);

			}
			break;

		default:
			fatal("Unknown state in scanner.");
		}
		yyerror((char *) 0);
		state = CMD;
		longjmp(errcatch,0);
	}
}

void
upper(s)
	char *s;
{
	while (*s != '\0') {
		if (islower(*s))
			*s = toupper(*s);
		s++;
	}
}

static void
help(ctab, s)
	struct tab *ctab;
	char *s;
{
	struct tab *c;
	int width, NCMDS;
	char *type;

	if (ctab == sitetab)
		type = "SITE ";
	else
		type = "";
	width = 0, NCMDS = 0;
	for (c = ctab; c->name != NULL; c++) {
		int len = strlen(c->name);

		if (len > width)
			width = len;
		NCMDS++;
	}
	width = (width + 8) &~ 7;
	if (s == 0) {
		int i, j, w;
		int columns, lines;

		lreply(214, "The following %scommands are recognized %s.",
		    type, "(* =>'s unimplemented)");
		columns = 76 / width;
		if (columns == 0)
			columns = 1;
		lines = (NCMDS + columns - 1) / columns;
		for (i = 0; i < lines; i++) {
			printf("   ");
			for (j = 0; j < columns; j++) {
				c = ctab + j * lines + i;
				printf("%s%c", c->name,
					c->implemented ? ' ' : '*');
				if (c + lines >= &ctab[NCMDS])
					break;
				w = strlen(c->name) + 1;
				while (w < width) {
					putchar(' ');
					w++;
				}
			}
			printf("\r\n");
		}
		(void) fflush(stdout);
		reply(214, "Direct comments to ftp-bugs@%s.", hostname);
		return;
	}
	upper(s);
	c = lookup(ctab, s);
	if (c == (struct tab *)0) {
		reply(502, "Unknown command %s.", s);
		return;
	}
	if (c->implemented)
		reply(214, "Syntax: %s%s %s", type, c->name, c->help);
	else
		reply(214, "%s%-*s\t%s; unimplemented.", type, width,
		    c->name, c->help);
}

static void
sizecmd(filename)
	char *filename;
{
	switch (type) {
	case TYPE_L:
	case TYPE_I: {
		struct stat stbuf;
		if (stat(filename, &stbuf) < 0 || !S_ISREG(stbuf.st_mode))
			reply(550, "%s: not a plain file.", filename);
		else
#ifdef ORIGINAL_SOURCE
			reply(213, "%qu", stbuf.st_size);
#else
			reply(213, "%qu", (unsigned long long) stbuf.st_size);
#endif /* ORIGINAL_SOURCE */
		break; }
	case TYPE_A: {
		FILE *fin;
		int c;
		off_t count;
		struct stat stbuf;
		fin = fopen(filename, "r");
		if (fin == NULL) {
			perror_reply(550, filename);
			return;
		}
		if (fstat(fileno(fin), &stbuf) < 0 || !S_ISREG(stbuf.st_mode)) {
			reply(550, "%s: not a plain file.", filename);
			(void) fclose(fin);
			return;
		}

		count = 0;
		while((c=getc(fin)) != EOF) {
			if (c == '\n')	/* will get expanded to \r\n */
				count++;
			count++;
		}
		(void) fclose(fin);

#ifdef ORIGINAL_SOURCE
		reply(213, "%qd", count);
#else
		reply(213, "%qd", (long long) count);
#endif /* ORIGINAL_SOURCE */
		break; }
	default:
		reply(504, "SIZE not implemented for Type %c.", "?AEIL"[type]);
	}
}
